--- old/usr/src/uts/common/io/nvme/nvme.c	2016-10-04 14:52:23.532791456 +0000
+++ new/usr/src/uts/common/io/nvme/nvme.c	2016-10-04 14:52:23.546228497 +0000
@@ -2507,6 +2507,7 @@
 	off_t regsize;
 	int i;
 	char name[32];
+	bd_ops_t l_bd_ops = nvme_bd_ops;
 
 	if (cmd != DDI_ATTACH)
 		return (DDI_FAILURE);
@@ -2643,8 +2644,12 @@
 		if (nvme->n_ns[i].ns_ignore)
 			continue;
 
+		if (!nvme->n_write_cache_present) {
+			l_bd_ops.o_sync_cache = NULL;
+		}
+
 		nvme->n_ns[i].ns_bd_hdl = bd_alloc_handle(&nvme->n_ns[i],
-		    &nvme_bd_ops, &nvme->n_prp_dma_attr, KM_SLEEP);
+		    &l_bd_ops, &nvme->n_prp_dma_attr, KM_SLEEP);
 
 		if (nvme->n_ns[i].ns_bd_hdl == NULL) {
 			dev_err(dip, CE_WARN,
